mcast6-queryfld01 6.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast6-queryfld01
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining an IPv6 multicast
  28. # group on a single socket, then receiving a large number of General Query
  29. #
  30. # Setup:
  31. # See testcases/network/stress/README
  32. #
  33. # Author:
  34. # Mitsuru Chinen <mitch@jp.ibm.com>
  35. #
  36. # History:
  37. # May 7 2006 - Created (Mitsuru Chinen)
  38. #
  39. #-----------------------------------------------------------------------
  40. # Uncomment line below for debug output.
  41. #trace_logic=${trace_logic:-"set -x"}
  42. $trace_logic
  43. # The test case ID, the test case count and the total number of test case
  44. TCID=mcast6-queryfld01
  45. TST_TOTAL=1
  46. TST_COUNT=1
  47. export TCID
  48. export TST_COUNT
  49. export TST_TOTAL
  50. # Make sure the value of LTPROOT
  51. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  52. export LTPROOT
  53. # Check the environmanet variable
  54. . check_envval || exit $TST_TOTAL
  55. # Dulation of the test [sec]
  56. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  57. # The number of the test link where tests run
  58. LINK_NUM=${LINK_NUM:-0}
  59. # Network portion of the IPv6 address
  60. NETWORK_PART="fec0:1:1:1"
  61. # Host portion of the IPv6 address
  62. LHOST_HOST_PART=":2" # local host
  63. RHOST_HOST_PART=":1" # remote host
  64. # Prefix of the Multicast Address
  65. MCAST_ADDR_PREFIX=ff0e:
  66. #-----------------------------------------------------------------------
  67. #
  68. # Function: do_cleanup
  69. #
  70. # Description:
  71. # Recover the system configuration
  72. #
  73. #-----------------------------------------------------------------------
  74. do_cleanup()
  75. {
  76. # Make sure to kill the multicast receiver and sender
  77. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  78. $LTP_RSH $RHOST killall -SIGHUP ns-icmpv6_sender >/dev/null 2>&1
  79. # Clean up each interface
  80. initialize_if lhost ${LINK_NUM}
  81. initialize_if rhost ${LINK_NUM}
  82. }
  83. #-----------------------------------------------------------------------
  84. #
  85. # Function: do_setup
  86. #
  87. # Description:
  88. # Configure the ssystem for the test
  89. #
  90. #-----------------------------------------------------------------------
  91. do_setup()
  92. {
  93. # Initialize the system configuration
  94. do_cleanup
  95. # Call do_cleanup function before exit
  96. trap do_cleanup 0
  97. # name of interface of the local/remote host
  98. lhost_ifname=`get_ifname lhost $LINK_NUM`
  99. if [ $? -ne 0 ]; then
  100. tst_resm TBROK "Failed to get the interface name at the local host"
  101. exit $TST_TOTAL
  102. fi
  103. rhost_ifname=`get_ifname rhost $LINK_NUM`
  104. if [ $? -ne 0 ]; then
  105. tst_resm TBROK "Failed to get the interface name at the remote host"
  106. exit $TST_TOTAL
  107. fi
  108. # Set IPv6 addresses to the interfaces
  109. add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  110. if [ $? -ne 0 ]; then
  111. tst_resm TBROK "Failed to add any IP address at the local host"
  112. exit 1
  113. fi
  114. add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  115. if [ $? -ne 0 ]; then
  116. tst_resm TBROK "Failed to add any IP address at the remote host"
  117. exit 1
  118. fi
  119. # IPv6 address of the local/remote host
  120. lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
  121. rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
  122. rhost_linklocal="fe80:${RHOST_HOST_PART}"
  123. # Make sure the connectvity
  124. check_icmpv6_connectivity $lhost_ifname $rhost_addr
  125. if [ $? -ne 0 ]; then
  126. tst_resm TBROK "There is no IPv6 connectivity."
  127. exit 1
  128. fi
  129. # Make sure the sysctl values
  130. sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
  131. if [ $? -ne 0 ]; then
  132. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  133. exit $TST_TOTAL
  134. fi
  135. sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
  136. sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
  137. }
  138. #-----------------------------------------------------------------------
  139. #
  140. # Main
  141. #
  142. #
  143. # Test description
  144. tst_resm TINFO "Verify that the kernel is not crashed when joining an IPv6 multicast group on a single socket, then receiving a large number of General Query in $NS_DURATION [sec]"
  145. do_setup
  146. # Run a multicast join tool
  147. ns-mcast_join -f 6 -I $lhost_ifname -n 1 -p $MCAST_ADDR_PREFIX >/dev/null
  148. if [ $? -ne 0 ]; then
  149. tst_resm TBROK "Failed to start multicast joining tool Please check the environment"
  150. exit 1
  151. fi
  152. # Send MLD General Query from the remote host
  153. ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-icmpv6_sender -I $rhost_ifname -S $rhost_linklocal -m -r 0 -t $NS_DURATION' ; echo $?'`
  154. if [ $ret -ne 0 ]; then
  155. tst_resm TBROK "Failed to start MLD querier"
  156. exit 1
  157. fi
  158. #-----------------------------------------------------------------------
  159. #
  160. # Clean up
  161. #
  162. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  163. tst_resm TPASS "Test is finished successfully."
  164. exit 0